import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class CompleteTX extends StatefulWidget {
  CompleteTX({this.title, this.detail, this.buttonText, this.back});
  final title;
  final detail;
  final buttonText;
  final back;

  _CompleteTX createState() => new _CompleteTX(title: title, detail: detail, buttonText: buttonText, back: back);
}

class _CompleteTX extends State<CompleteTX> {
  _CompleteTX({this.title, this.detail, this.buttonText, this.back});
  final title;
  final detail;
  final buttonText;
  final back;
  buildForPhone(Orientation orientation) {
    return Scaffold(
      backgroundColor: Color(0xFFFFFFFF),
      body: Align(
        alignment: Alignment.center,
        child: Column(
          children: <Widget>[
            SizedBox(
              height: MediaQuery.of(context).size.height * 0.15,
            ),
            new Container(
              alignment: Alignment.center,
              height: MediaQuery.of(context).size.height * 0.1,
              width: MediaQuery.of(context).size.width * 0.15,
              child: Image.asset(
                'assets/image/complete.png',
                scale: 1,
              ),
            ),
            new Container(
              alignment: Alignment.center,
              height: MediaQuery.of(context).size.height * 0.05,
              width: MediaQuery.of(context).size.width * 0.8,
              child: new Text(
                title,
                style: TextStyle(
                    color: Color(0xff000000).withOpacity(1),
                    fontFamily: 'Proxima Nova',
                    fontWeight: FontWeight.normal,
                    fontSize: 15.0),
              ),
            ),
            new Container(
              alignment: Alignment.center,
              height: MediaQuery.of(context).size.height * 0.2,
              width: MediaQuery.of(context).size.width * 0.8,
              child: new Text(
                detail,
                style: TextStyle(
                    color: Color(0xff000000).withOpacity(1),
                    fontFamily: 'Proxima Nova',
                    fontWeight: FontWeight.normal,
                    fontSize: 17.0),
              ),
            ),
            new Container(
              alignment: Alignment.center,
              height: MediaQuery.of(context).size.height * 0.07,
              width: MediaQuery.of(context).size.width * 0.9,
              child: ButtonTheme(
                minWidth: MediaQuery.of(context).size.width * 0.95,
                height: MediaQuery.of(context).size.height * 0.07,
                child: new FlatButton(
                    shape: new RoundedRectangleBorder(
                      borderRadius: new BorderRadius.circular(8.0),
                    ),
                    disabledColor: Color(0xff150e23).withOpacity(0.8),
                    color: Color(0xff150e23).withOpacity(0.8),
                    onPressed: (() => {
                      Navigator.pushAndRemoveUntil(
                          context,
                          MaterialPageRoute(
                              builder: (context) => back
                          ),
                              (Route<dynamic> route) => false)
                    }),
                    child: new Text(
                      buttonText,
                      style: TextStyle(
                          color: Color(0xffB4E60D),
                          fontFamily: 'Proxima Nova',
                          fontSize: 18,
                          fontWeight: FontWeight.normal),
                    )),
              ),
            ),
          ],
        ),
      ),
    );
  }

  buildForTablet(Orientation orientation) {
    return Scaffold();
  }

  int tabMenu = 0;
  changeMenu(_number) async {
    setState(() {
      tabMenu = _number;
    });
  }

  @override
  Widget build(BuildContext context) {
    final double shortestSide = MediaQuery.of(context).size.shortestSide;
    final bool useMobileLayout = shortestSide < 600.0;
    final Orientation orientation = MediaQuery.of(context).orientation;
    return Scaffold(
      body: useMobileLayout
          ? buildForPhone(orientation)
          : buildForTablet(orientation),
    );
  }
}
