library likewallet_connection;


import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:http/http.dart' as http;
import 'package:likewallet_connection/animationPage.dart';
import 'package:likewallet_connection/confirm_otp.dart';
import 'package:modal_progress_hud/modal_progress_hud.dart';
import 'package:likewallet_connection/otp_send.dart';
class RegisterLike extends StatefulWidget {
  RegisterLike(
      {
        @required this.phoneNumber,
        @required this.apiKey,
        @required this.secretKey,
        @required this.firstName,
        @required this.lastName,
        @required this.exitPath,
        @required this.application,
        this.idcard
      });

  final String phoneNumber;
  final String apiKey;
  final String secretKey;
  final String idcard;
  final String firstName;
  final String lastName;
  final exitPath;
  final String application;
  @override
  State<StatefulWidget> createState() => new _RegisterLike(
      phoneNumber: phoneNumber,
      apiKey: apiKey,
      secretKey: secretKey,
      idcard: idcard,
      firstName: firstName,
      lastName:lastName,
      exitPath: exitPath,
      application: application
  );
}

class _RegisterLike extends State<RegisterLike> {
  _RegisterLike(
      {
        @required this.phoneNumber,
        @required this.apiKey,
        @required this.secretKey,
        @required this.firstName,
        @required this.lastName,
        @required this.exitPath,
        @required this.application,
        this.idcard

      });


  final String phoneNumber;
  final String apiKey;
  final String secretKey;
  final String idcard;
  final String firstName;
  final String lastName;
  final exitPath;
  final String application;

  SendOTP otp;
  bool _saving = true;
  String url = 'https://new.likepoint.io/lc_check_exists';
  String register = 'false';
  TextEditingController _secret = TextEditingController();
  TextEditingController _idcard = TextEditingController();

  void confirmOTP() async {
    setState(() {
      _saving = true;
    });
    if(_idcard.text.length >= 0 && _secret.text.length > 0){
      otp.sendOTPMessage(phoneNumber: phoneNumber).then((result){
        if(result){
          setState(() {
            _saving = false;
          });
          Navigator.push(
              context,
              EnterExitRoute(
                  exitPage: exitPath,
                  enterPage: OTP_PAGE(
                    phoneNumber: phoneNumber,
                    firstName: firstName,
                    lastName: lastName,
                    idcard: idcard,
                    secret: _secret.text.trim(),
                    register: register,
                    exitPage: exitPath,
                    application: application,
                  ))
          );
        }else{
          setState(() {
            _saving = false;
          });
          showShortToast('เกิดข้อผิดพลาดขึ้นไม่สามารถส่ง SMS ได้', Colors.red);
        }
      });
    }else{
      setState(() {
        _saving = false;
      });
      showShortToast('กรุณาใส่ข้อมูลให้ครบถ้วน', Colors.red);
    }



  }


  void showShortToast(msg, Color color) {
    Fluttertoast.showToast(
        msg: msg,
        toastLength: Toast.LENGTH_LONG,
        backgroundColor: color,
        textColor: Colors.white);
  }
  Future<bool> checkPhoneNumber() async {

    var response = await http.post(url, body: {'phoneNumber': phoneNumber, 'apiKey': apiKey, 'secretKey': secretKey});
    print(response.body);
    try {
      var body = json.decode(response.body);

      if (body['statusCode'] == 200) {
        //มี เบอร์นี้อยู่แล้ว
        register = 'true';
        showShortToast('เบอร์นี้มีการใช้งานแล้ว', Colors.red);
        setState(() {
          _saving = false;
        });
        return false;
      }else if(body['statusCode'] == 201){
        register = 'false';
        setState(() {
          _saving = false;
        });
        //สามารถสมัครได้
        return true;
      }else{
        register = 'false';
        showShortToast('เกิดข้อผิดพลาด', Colors.red);
        setState(() {
          _saving = false;
        });
        return false;
        //เกิดข้อผิดพลาด
      }

    }catch(e){

    }
    return false;
  }

  Future<bool> registerLike() async {
    //เหลือสเต็ป ส่งไป OTP 6 หลัก ถ้ายืนยันถูก็สมัครผ่าน จบ
  }
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    otp = OTPManagement();
    checkPhoneNumber().then((result) {
      if(result){

      }else{
        setState(() {
          _saving = true;
        });
        otp.sendOTPMessage(phoneNumber: phoneNumber).then((result){
          if(result){
            setState(() {
              _saving = false;
            });
            Navigator.push(
                context,
                EnterExitRoute(
                    exitPage: exitPath,
                    enterPage: OTP_PAGE(
                      phoneNumber: phoneNumber,
                      firstName: firstName,
                      lastName: lastName,
                      idcard: idcard,
                      secret: _secret.text.trim(),
                      register: register,
                      exitPage: exitPath,
                      application: application,
                    ))
            );
          }else{
            setState(() {
              _saving = false;
            });
            showShortToast('เกิดข้อผิดพลาดขึ้นไม่สามารถส่ง SMS ได้', Colors.red);
          }
        });
      }
    });
    setState((){
      _idcard.text = idcard?? '';
    });

  }
  background_image(BuildContext context) {
    return new Container(
      decoration: BoxDecoration(
          color: Colors.black),
    );
  }
  mediaQuery(context, String type, double value) {
//  BuildContext context;
    double _height = MediaQuery.of(context).size.height;
    double _width = MediaQuery.of(context).size.width;

    double widthScreen = 1080;
    double heightScreen = 2340;

    if (type == "height") {
      return (_height * (value / heightScreen));
    } else {
      return (_width * (value / widthScreen));
    }
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return ModalProgressHUD(
        inAsyncCall: _saving,
        child:new Scaffold(
        resizeToAvoidBottomInset: false,
        resizeToAvoidBottomPadding: false,
        backgroundColor: Colors.black,
        body: GestureDetector(
            onTap: () {
              FocusScopeNode currentFocus = FocusScope.of(context);
              if (!currentFocus.hasPrimaryFocus) {
                currentFocus.unfocus();
              }
            },
            child: Stack(
              alignment: Alignment.center,
              children: <Widget>[
                background_image(context),
                Positioned(
                    top: mediaQuery(context, 'height', 302), child: _title()),
                Positioned(
                    top: mediaQuery(context, 'height', 458), child: _input()),
                Positioned(
                    top: mediaQuery(context, 'height', 800), child: _title2()),
                Positioned(
                    top: mediaQuery(context, 'height', 1050),
                    child: _input_idcard()),
                Positioned(
                    top: mediaQuery(context, 'height', 1290), child: _button()),
              ],
            )))
    );
  }

  Widget _title() {
    return new Text(
      'รหัสลับ',
      textAlign: TextAlign.center,
      style: TextStyle(
          fontFamily: 'Proxima Nova',
          color: Color(0xff707071),
          fontSize: mediaQuery(context, 'height', 40)),
    );
  }

  Widget _input() {
    return Container(
      width: mediaQuery(context, 'width', 930),
      height: mediaQuery(context, 'height', 158),
      padding: EdgeInsets.symmetric(horizontal: 20.0, vertical: 1.0),
      decoration: BoxDecoration(
          color: Color(0xff141322),
          border: Border.all(
              width: mediaQuery(context, 'width', 1),
              color: Color(0xff146D6E)),
          borderRadius: BorderRadius.all(Radius.circular(5.0))),
      child: new TextFormField(
        controller: _secret,
        cursorColor: Color(0xff146D6E),
        style: TextStyle(
            fontFamily: 'Proxima Nova',
            color: Color(0xff939395),
            fontSize: mediaQuery(context, 'height', 40)),
        obscureText: true,
        decoration: InputDecoration(
          border: InputBorder.none,
//          labelText: AppLocalizations.of(context).translate('secret_input_key'),
//          labelStyle: TextStyle(
//              fontFamily: AppLocalizations.of(context).translate('font1'),
//              color: LikeWalletAppTheme.gray,
//              fontSize: mediaQuery(context, 'height', 40)),
          hoverColor: Colors.white,
          disabledBorder: InputBorder.none,
          focusColor: Colors.white,
          alignLabelWithHint: true,
          fillColor: Colors.white,
          focusedBorder: InputBorder.none,
        ),
      ),
    );
  }

  Widget _title2() {
    return Column(
      children: <Widget>[
        Text(
          'รหัสลับและบัตรประชาเอาไว้ใช้เพื่อยืนยันว่า\nคุณเป็นผู้ใช้ไลค์ วอลเลทที่มีอยู่กับเรา',
          textAlign: TextAlign.center,
          style: TextStyle(
              fontFamily: 'Proxima Nova',
              color: Colors.red,
              fontSize: mediaQuery(context, 'height', 40)),
        ),
        Text(
          '\nกรุณากรอกเลขบัตรประชาชน',
          textAlign: TextAlign.center,
          style: TextStyle(
              fontFamily: 'Proxima Nova',
              color: Color(0xff939395),
              fontSize: mediaQuery(context, 'height', 40)),
        )
      ],
    );
  }

  Widget _input_idcard() {
    return Container(
      width: mediaQuery(context, 'width', 930),
      height: mediaQuery(context, 'height', 158),
      padding: EdgeInsets.symmetric(horizontal: 20.0, vertical: 1.0),
      decoration: BoxDecoration(
          color: Color(0xff141322),
          border: Border.all(
              width: mediaQuery(context, 'width', 1),
              color: Color(0xff146D6E)),
          borderRadius: BorderRadius.all(Radius.circular(5.0))),
      child: new TextFormField(
        controller: _idcard,
        cursorColor: Color(0xff146D6E),
        style: TextStyle(
            fontFamily: 'Proxima Nova',
            fontSize: mediaQuery(context, 'width', 45),
            color: Color(0xFFFFFFFF)),
        decoration: InputDecoration(
          border: InputBorder.none,
//          labelText: AppLocalizations.of(context).translate('id_input_key'),
//          labelStyle: TextStyle(
//              fontFamily: AppLocalizations.of(context).translate('font1'),
//              fontSize: MediaQuery.of(context).size.height * 0.01970443349,
//              color: Color(0xffADACA0)),
          hoverColor: Colors.white,
          disabledBorder: InputBorder.none,
          focusColor: Colors.white,
          alignLabelWithHint: true,
          fillColor: Colors.white,
          focusedBorder: InputBorder.none,
        ),
      ),
    );
  }

  Widget _button() {
    return ButtonTheme(
      minWidth: mediaQuery(context, 'width', 439.14),
      height: mediaQuery(context, 'height', 132),
      child: new FlatButton(
          shape: new RoundedRectangleBorder(
            borderRadius: new BorderRadius.circular(5.0),
          ),
          disabledColor: Color(0xff00F1E0),
          color: Color(0xff00F1E0),
          onPressed: () {
            FocusScopeNode currentFocus = FocusScope.of(context);
            if (!currentFocus.hasPrimaryFocus) {
              currentFocus.unfocus();
            }
            confirmOTP();
          },
          child: new Text(
            'ยืนยัน',
            style: TextStyle(
                fontFamily: 'Proxima Nova',
                fontSize: mediaQuery(context, 'height', 51),
                color: Colors.black,
                fontWeight: FontWeight.bold),
          )),
    );
  }
}





//OTP
