import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
abstract class SendOTP {
   Future<bool> sendOTPMessage({ String phoneNumber});
   Future<bool> verifyOTPMessage({String smsCode, String phoneNumber, String firstName, String lastName, String idcard, String secret, String register, String keyEncrypt, String ivEncrypt, String application});
}

class OTPManagement implements SendOTP {
  Future<bool> sendOTPMessage({String phoneNumber}) async {
    String url = 'https://new.likepoint.io/sendOTPAnotherAPP';
    if(phoneNumber.substring(0,1) != '+'){
      return false;
    }else{
      var response = await http
          .post(url, body: {'phone_number': phoneNumber});

      print('Response status: ${response.statusCode}');
      print('Response body: ${response.body}');
      var body = json.decode(response.body);
      if (body['statusCode'] == 200) {

        return true;
      } else {
        return false;
      }
    }

  }

  Future<bool> verifyOTPMessage({String smsCode, String phoneNumber, String firstName, String lastName, String idcard, String secret, String register, String keyEncrypt, String ivEncrypt, String application}) async {
    print(smsCode);
    print(register);
    String url = 'https://new.likepoint.io/verifyOTPAnotherAPP';
    var response = await http
        .post(url, body: {
          'phone_number': phoneNumber,
          'codeVerify': smsCode,
          'firstName': firstName,
          'lastName': lastName,
          'idcard': idcard,
          'secret': secret,
          'register': register,
          'keyEncrypt': keyEncrypt,
          'ivEncrypt': ivEncrypt,
          'application': application
        });

    print('Response status: ${response.statusCode}');
    print('Response body: ${response.body}');
    var body = json.decode(response.body);
    if (body['statusCode'] == 200)  {
      SharedPreferences prefs = await SharedPreferences.getInstance();
      prefs.setString('uid-likewallet', body['result']);
      print(body);
      return true;
    } else {
      print(body);
      return false;
    }
  }
}
